scala.tools.nsc.Global

# patmat

###
Related Doc: package Global

#### object patmat extends SubComponent with PatternMatching

Source
  Global.scala

Linear Supertypes
PatternMatching, ScalacPatternExpanders, MatchWarnings, MatchOptimization, MatchAnalysis, MatchApproximation, Solving, ScalaLogic, TreeAndTypeAnalysis, Logic, MatchCps, MatchTreeMaking, MatchCodeGen, MatchTranslation, Interface, TreeDSL, Debugging, TypingTransformers, Transform, SubComponent, AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. patmat
2. PatternMatching
3. ScalacPatternExpanders
4. MatchWarnings
5. MatchOptimization
6. MatchAnalysis
7. MatchApproximation
8. Solving
9. ScalaLogic
10. TreeAndTypeAnalysis
11. Logic
12. MatchCps
13. MatchTreeMaking
14. MatchCodeGen
15. MatchTranslation
16. Interface
17. TreeDSL
18. Debugging
19. TypingTransformers
20. Transform
21. SubComponent
22. AnyRef
23. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### implicit class AlignedOps extends AnyRef

   Definition Classes
     ScalacPatternExpanders

2. #### trait CNF extends PropositionalLogic

   Definition Classes
     Solving

3. #### trait CheckableTreeAndTypeAnalysis extends AnyRef

   Definition Classes
     TreeAndTypeAnalysis

4. #### trait CodegenCore extends MatchMonadInterface

   Definition Classes
     MatchCodeGen

5. #### trait CommonSubconditionElimination extends OptimizedCodegen with MatchApproximator

   Definition Classes
     MatchOptimization

6. #### trait MatchAnalyzer extends MatchApproximator

   Definition Classes
     MatchAnalysis

7. #### trait MatchApproximator extends TreeMakers with TreesAndTypesDomain

   Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

   Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

   Definition Classes
     MatchApproximation

8. #### trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

       type Matcher[P[_], M[+_], A] = {
         def flatMap[B](f: P[A] => M[B]): M[B]
         def orElse[B >: A](alternative: => M[B]): M[B]
       }

       abstract class MatchStrategy[P[_], M[+_]] {
         // runs the matcher on the given input
         def runOrElse[T, U](in: P[T])(matcher: P[T] => M[U]): P[U]

         def zero: M[Nothing]
         def one[T](x: P[T]): M[T]
         def guard[T](cond: P[Boolean], then: => P[T]): M[T]
       }

   P and M are derived from one's signature (`def one[T](x: P[T]): M[T]`)

   if no `__match` is found, we assume the following implementation (and generate optimized code accordingly)

       object __match extends MatchStrategy[({type Id[x] = x})#Id, Option] {
         def zero = None
         def one[T](x: T) = Some(x)
         // NOTE: guard's return type must be of the shape M[T], where M is the monad in which the pattern match should be interpreted
         def guard[T](cond: Boolean, then: => T): Option[T] = if(cond) Some(then) else None
         def runOrElse[T, U](x: T)(f: T => Option[U]): U = f(x) getOrElse (throw new MatchError(x))
       }

   Definition Classes
     Interface

9. #### trait MatchOptimizer extends OptimizedCodegen with SwitchEmission with CommonSubconditionElimination

   Definition Classes
     MatchOptimization

10. #### class MatchTransformer extends TypingTransformer

    Definition Classes
      PatternMatching

11. #### trait MatchTranslator extends PatternMatching.TreeMakers with PatternMatching.TreeMakerWarnings

    Definition Classes
      MatchTranslation

12. #### trait OptimizedCodegen extends CodegenCore with TypedSubstitution with MatchMonadInterface

    Definition Classes
      MatchCodeGen

13. #### class OptimizingMatchTranslator extends MatchTranslator with MatchOptimizer with MatchAnalyzer with Solver

    Definition Classes
      PatternMatching

14. #### type PatternAligned = transform.patmat.ScalacPatternExpanders.ScalacPatternExpander.Aligned

    Definition Classes
      ScalacPatternExpanders

15. #### class Phase extends StdPhase

    The phase defined by this transform

    The phase defined by this transform

    Definition Classes
      Transform

16. #### trait PropositionalLogic extends AnyRef

    Definition Classes
      Logic

17. #### trait PureCodegen extends CodegenCore with PureMatchMonadInterface

    Definition Classes
      MatchCodeGen

18. #### trait PureMatchMonadInterface extends MatchMonadInterface

    Definition Classes
      MatchCodeGen

19. #### class PureMatchTranslator extends MatchTranslator with PureCodegen

    Definition Classes
      PatternMatching

20. #### trait ScalacPatternExpander extends PatternExpander[Global.Tree, Global.Type]

    Definition Classes
      ScalacPatternExpanders

21. #### trait Solver extends CNF

    Definition Classes
      Solving

22. #### abstract class StdPhase extends GlobalPhase

    A standard phase template

    A standard phase template

    Definition Classes
      SubComponent

23. #### final case class Suppression(suppressExhaustive: Boolean, suppressUnreachable: Boolean) extends Product with Serializable

    Definition Classes
      MatchTreeMaking

24. #### trait SwitchEmission extends TreeMakers with MatchMonadInterface

    Definition Classes
      MatchOptimization

25. #### trait TreeMakerWarnings extends AnyRef

    Definition Classes
      MatchWarnings

26. #### trait TreeMakers extends TypedSubstitution with CodegenCore

    Definition Classes
      MatchTreeMaking

27. #### trait TreesAndTypesDomain extends PropositionalLogic with CheckableTreeAndTypeAnalysis

    Definition Classes
      ScalaLogic

28. #### trait TypedSubstitution extends MatchMonadInterface

    Definition Classes
      Interface

29. #### abstract class TypingTransformer extends Global.Transformer

    Definition Classes
      TypingTransformers

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### object CODE

   Definition Classes
     TreeDSL

5. #### object Suppression extends Serializable

   Definition Classes
     MatchTreeMaking

6. #### final def afterOwnPhase[T](op: ⇒ T): T

   Definition Classes
     SubComponent
   Annotations
     @inline()

7. #### def alignAcrossRows(xss: List[List[Any]], sep: String, lineSep: String = "\n"): String

   Definition Classes
     Logic

8. #### object alignPatterns extends ScalacPatternExpander

   Definition Classes
     ScalacPatternExpanders

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10. #### final def beforeOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

11. #### def binderTypeImpliedByPattern(pat: Global.Tree, pt: Global.Type, binder: Global.Symbol): Global.Type

    Compute the type T implied for a value `v` matched by a pattern `pat` (with expected type `pt`).

    Compute the type T implied for a value `v` matched by a pattern `pat` (with expected type `pt`).

    Usually, this is the pattern's type because pattern matching implies instance-of checks.

    However, Stable Identifier and Literal patterns are matched using `==`, which does not imply a type for the binder that binds the matched value.

    See SI-1503, SI-5024: don't cast binders to types we're not sure they have

    TODO: update spec as follows (deviation between `**`):

    A pattern binder x@p consists of a pattern variable x and a pattern p. The type of the variable x is the static type T **IMPLIED BY** the pattern p. This pattern matches any value v matched by the pattern p **Deleted: , provided the run-time type of v is also an instance of T, ** and it binds the variable name to that value.

    Addition: A pattern `p` _implies_ a type `T` if the pattern matches only values of the type `T`.

    Definition Classes
      TreeAndTypeAnalysis

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### final def dealiasWiden(tp: Global.Type): Global.Type

    Attributes
      protected
    Definition Classes
      Interface

14. #### object debug

    Definition Classes
      Debugging

15. #### def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent

16. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

17. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

18. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

19. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

20. #### val global: Global.this.type

    The global environment; overridden by instantiation in Global.

    The global environment; overridden by instantiation in Global.

    Definition Classes
      patmat → ScalacPatternExpanders → TreeDSL → Debugging → TypingTransformers → SubComponent

21. #### final def hasStableSymbol(p: Global.Tree): Boolean

    Attributes
      protected
    Definition Classes
      Interface

22. #### def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    returns

      the hash code value for this object.

    Definition Classes
      SubComponent → AnyRef → Any

23. #### val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent

24. #### def instanceOfTpImplies(tp: Global.Type, tpImplied: Global.Type): Boolean

    Definition Classes
      TreeAndTypeAnalysis

25. #### val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent

26. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

27. #### final def mkFALSE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

28. #### final def mkTRUE: Global.Literal

    Attributes
      protected
    Definition Classes
      Interface

29. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

30. #### def newPhase(prev: nsc.Phase): StdPhase

    Create a new phase which applies transformer

    Create a new phase which applies transformer

    Definition Classes
      Transform → SubComponent

31. #### def newTransformer(unit: Global.CompilationUnit): Global.Transformer

    The transformer factory

    The transformer factory

    Definition Classes
      PatternMatching → Transform

32. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

33. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

34. #### def ownPhase: nsc.Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent

35. #### val phaseName: String

    The name of the phase

    The name of the phase

    Definition Classes
      PatternMatching → SubComponent

36. #### def phaseNewFlags: Long

    New flags defined by the phase which are not valid before

    New flags defined by the phase which are not valid before

    Definition Classes
      SubComponent

37. #### def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent

38. #### def removeCPSFromPt(pt: Global.Type): Global.Type

    Definition Classes
      MatchCps

39. #### val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent

40. #### val runsAfter: collection.immutable.List[String]

    Names of phases that must run before this phase.

    Names of phases that must run before this phase.

    Definition Classes
      patmat → SubComponent

41. #### val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent

42. #### val runsRightAfter: None.type

    Name of the phase that this phase must follow immediately.

    Name of the phase that this phase must follow immediately.

    Definition Classes
      patmat → SubComponent

43. #### def sameValue(a: Global.Tree, b: Global.Tree): Boolean

    Definition Classes
      TreeAndTypeAnalysis

44. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

45. #### val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent

46. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

47. #### object vpmName

    Definition Classes
      Interface

48. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

49. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

50. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from PatternMatching

### Inherited from ScalacPatternExpanders

### Inherited from MatchWarnings

### Inherited from MatchOptimization

### Inherited from MatchAnalysis

### Inherited from MatchApproximation

### Inherited from Solving

### Inherited from ScalaLogic

### Inherited from TreeAndTypeAnalysis

### Inherited from Logic

### Inherited from MatchCps

### Inherited from MatchTreeMaking

### Inherited from MatchCodeGen

### Inherited from MatchTranslation

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from Debugging

### Inherited from TypingTransformers

### Inherited from Transform

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Ungrouped